clear all
rng(1); % new way to control random number generation

case_name = 'Case1';

%% Case with gmdp_example_epidemio default arguments
[GMDP] = gmdp_example_epidemio(0.2,0.5,0.8,4);
discount = 0.9;


%% Test 1 - Test gmdp_globalize
P1(:,:,1) = [ 0.5120    0.1280    0.1280    0.0320    0.1280    0.0320    0.0320    0.0080
         0    0.3200         0    0.4800         0    0.0800         0    0.1200
         0         0    0.1600    0.2400         0         0    0.2400    0.3600
         0         0         0    0.4000         0         0         0    0.6000
         0         0         0         0    0.3200    0.0800    0.4800    0.1200
         0         0         0         0         0    0.2000         0    0.8000
         0         0         0         0         0         0    0.4000    0.6000
         0         0         0         0         0         0         0    1.0000 ];
 P1(:,:,2) =  [ 0.6400         0    0.1600         0    0.1600         0    0.0400         0
    0.2560    0.0640    0.3840    0.0960    0.0640    0.0160    0.0960    0.0240
         0         0    0.4000         0         0         0    0.6000         0
         0         0    0.3200    0.0800         0         0    0.4800    0.1200
         0         0         0         0    0.4000         0    0.6000         0
         0         0         0         0    0.1600    0.0400    0.6400    0.1600
         0         0         0         0         0         0    1.0000         0
         0         0         0         0         0         0    0.8000    0.2000];
P1(:,:,3) =  [ 0.6400    0.1600         0         0    0.1600    0.0400         0         0
         0    0.8000         0         0         0    0.2000         0         0
    0.1280    0.1920    0.0320    0.0480    0.1920    0.2880    0.0480    0.0720
         0    0.3200         0    0.0800         0    0.4800         0    0.1200
         0         0         0         0    0.8000    0.2000         0         0
         0         0         0         0         0    1.0000         0         0
         0         0         0         0    0.3200    0.4800    0.0800    0.1200
         0         0         0         0         0    0.8000         0    0.2000];
P1(:,:,4) = [  0.8000         0         0         0    0.2000         0         0         0
    0.6400    0.1600         0         0    0.1600    0.0400         0         0
    0.3200         0    0.0800         0    0.4800         0    0.1200         0
    0.2560    0.0640    0.0640    0.0160    0.3840    0.0960    0.0960    0.0240
         0         0         0         0    1.0000         0         0         0
         0         0         0         0    0.8000    0.2000         0         0
         0         0         0         0    0.8000         0    0.2000         0
         0         0         0         0    0.6400    0.1600    0.1600    0.0400];
P1(:,:,5) = [ 0.6400    0.1600    0.1600    0.0400         0         0         0         0
         0    0.4000         0    0.6000         0         0         0         0
         0         0    0.4000    0.6000         0         0         0         0
         0         0         0    1.0000         0         0         0         0
    0.2560    0.0640    0.3840    0.0960    0.0640    0.0160    0.0960    0.0240
         0    0.1600         0    0.6400         0    0.0400         0    0.1600
         0         0    0.3200    0.4800         0         0    0.0800    0.1200
         0         0         0    0.8000         0         0         0    0.2000];
P1(:,:,6) =  [ 0.8000         0    0.2000         0         0         0         0         0
    0.3200    0.0800    0.4800    0.1200         0         0         0         0
         0         0    1.0000         0         0         0         0         0
         0         0    0.8000    0.2000         0         0         0         0
    0.3200         0    0.4800         0    0.0800         0    0.1200         0
    0.1280    0.0320    0.5120    0.1280    0.0320    0.0080    0.1280    0.0320
         0         0    0.8000         0         0         0    0.2000         0
         0         0    0.6400    0.1600         0         0    0.1600    0.0400];
P1(:,:,7) =  [0.8000    0.2000         0         0         0         0         0         0
         0    1.0000         0         0         0         0         0         0
    0.3200    0.4800    0.0800    0.1200         0         0         0         0
         0    0.8000         0    0.2000         0         0         0         0
    0.6400    0.1600         0         0    0.1600    0.0400         0         0
         0    0.8000         0         0         0    0.2000         0         0
    0.2560    0.3840    0.0640    0.0960    0.0640    0.0960    0.0160    0.0240
         0    0.6400         0    0.1600         0    0.1600         0    0.0400];
P1(:,:,8) =  [1.0000         0         0         0         0         0         0         0
    0.8000    0.2000         0         0         0         0         0         0
    0.8000         0    0.2000         0         0         0         0         0
    0.6400    0.1600    0.1600    0.0400         0         0         0         0
    0.8000         0         0         0    0.2000         0         0         0
    0.6400    0.1600         0         0    0.1600    0.0400         0         0
    0.6400         0    0.1600         0    0.1600         0    0.0400         0
    0.5120    0.1280    0.1280    0.0320    0.1280    0.0320    0.0320    0.0080 ];
R1 =  [12     8     8     4     8     4     4     0
    10     8     6     4     6     4     2     0
    10     6     8     4     6     2     4     0
     8     6     6     4     4     2     2     0
    10     6     6     2     8     4     4     0
     8     6     4     2     6     4     2     0
     8     4     6     2     6     2     4     0
     6     4     4     2     4     2     2     0   ];


%% Test 2 - Test gmdp_eval_policy_MF with default arguments
Vloc2{1} = [ 23.8463   23.8463   19.9995   19.9995 ]';
Vloc2{2} = [ 23.1289   23.1289   19.9995   19.9995   23.1289   23.1289   19.9995   19.9995 ]';
Vloc2{3} = [ 23.8463   19.9995   23.8463   19.9995 ]';


%% Test 3 - Test gmdp_eval_policy_MF with different policyloc and Qloc0
Vloc3{1} = [ 0 0 0 0 ]';
Vloc3{2} = [ 0 0 0 0 0 0 0 0 ]';
Vloc3{3} = [ 0 0 0 0 ]';


%% Test 4 - Test gmdp_eval_policy_MF with different policyloc, Qloc0 and Tend
Vloc4{1} = [ 6.6405    6.3348    4.1780    1.7249 ]';
Vloc4{2} = [ 6.7154    1.2179    4.0302    0.9105    6.7154    1.2179    4.0302    0.9105 ]';
Vloc4{3} = [ 6.3072    3.7041    0.8615    0.6363 ]';


%% Test 5 - Test gmdp_policy_iteration_MF with default arguments
policyloc5{1}=[ 1     2     2     2 ]';
policyloc5{2}=[ 1     2     2     2     2     2     2     2 ]';
policyloc5{3}=[ 1     2     2     2 ]';
Vloc5{1}=[ 29.8927   25.3831   25.5436   25.0881 ]';
Vloc5{2}=[ 25.5663   21.2526   21.1095   20.8445   21.2526   20.9732   20.8445   20.6083 ]';
Vloc5{3}=[ 29.8927   25.5436   25.3831   25.0881 ]';
iter5=2;


%% Test 6 - Test gmdp_policy_iteration_MF with different policyloc, max_iter and max_iter_update
policyloc6{1}=[ 1     2     2     2 ]';
policyloc6{2}=[ 1     2     2     2     2     2     2     2 ]';
policyloc6{3}=[ 1     2     2     2 ]';
Vloc6{1}=[ 29.8927   25.3831   25.5436   25.0881 ]';
Vloc6{2}=[ 25.5663   21.2526   21.1095   20.8445   21.2526   20.9732   20.8445   20.6083 ]';
Vloc6{3}=[ 29.8927   25.5436   25.3831   25.0881 ]';
iter6=2;


%% Test 7 - Test gmdp_linear_programming
policyloc7{1}=[ 1     1     2     2 ]';
policyloc7{2}=[ 1     1     2     2     1     1     2     2 ]';
policyloc7{3}=[ 1     2     1     2 ]';
